/*	$Id: CProjectMakeFile.h 364 2005-06-24 16:55:00Z tappe $
	
	Copyright 2005 Oliver Tappe
	
	Distributed under the MIT License
*/

#ifndef CPROJECTMAKEFILE_H
#define CPROJECTMAKEFILE_H

#include "CProjectFile.h"

class CProjectMakeFile : public CProjectFile
{
	typedef CProjectFile inherited;
public:
	CProjectMakeFile();
	CProjectMakeFile(const char* path);
	virtual ~CProjectMakeFile();
	
	virtual status_t Parse(const BString& contents);
	virtual bool HasBeenParsed() const	{ return true; }
	virtual bool HaveProjectInfo() const
													{ return fHaveProjectInfo; }

protected:
	virtual void GetText(BString &docText) const;
	virtual void SetText(const BString& docText);
private:
	const char* _AddGroup(const char* name);
	
	BString fHeader;
	BString fFooter;
	bool fHaveProjectInfo;
};

#endif
